﻿Imports C1.Win.C1TrueDBGrid
Public Class Form1
    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load

        C1TrueDBGrid1.DataSource = GetTable()
        AddHandler C1TrueDBGrid1.KeyDown, AddressOf C1TrueDBGrid1_KeyDown

        'Col 4 invisible
        C1TrueDBGrid1.FocusedSplit.DisplayColumns(3).Visible = False

    End Sub

    Private Sub C1TrueDBGrid1_KeyDown(sender As Object, e As KeyEventArgs)

        'when Ctrl+C is pressed
        If e.Control AndAlso e.KeyCode = Keys.C Then

            'copy the data
            CopyDataToClipboard(C1TrueDBGrid1, ControlChars.Tab)

            'suppress the keypress so that the grid does not handle Ctrl+C internally
            e.SuppressKeyPress = True

        End If

    End Sub

    ''' <summary>
    ''' Copies data of selected range of specified C1TrueDBGrid to the Clipboard
    ''' </summary>
    Private Sub CopyDataToClipboard(c1TrueDBGrid1 As C1TrueDBGrid, separatorChar As Char)

        Dim copyData = String.Empty
        If c1TrueDBGrid1.SelectedRows.Count > 0 Then

            For Each row As Integer In c1TrueDBGrid1.SelectedRows
                For Each col As C1DataColumn In c1TrueDBGrid1.SelectedCols

                    'skip the column if not visible
                    Dim displayCol = c1TrueDBGrid1.FocusedSplit.DisplayColumns.IndexOf(col)
                    If Not c1TrueDBGrid1.FocusedSplit.DisplayColumns(displayCol).Visible Then Continue For

                    copyData += col.CellText(row) 'add all data in a string
                    copyData += separatorChar     'add the separator character between two cell values

                Next
                copyData = copyData.Remove(copyData.Length - 1) 'remove the extra separator character after the last cell data
                copyData += ControlChars.NewLine   'add a newline character after every row
            Next

            Clipboard.SetText(copyData, TextDataFormat.UnicodeText)           'set our copied text in the Clipboard

        End If
    End Sub

    ''' <summary>
    ''' Sample data for the Grid
    ''' </summary>
    Private Function GetTable() As DataTable
        Dim dt As New DataTable()

        For i As Integer = 1 To 7 - 1

            If i Mod 2 = 0 Then
                dt.Columns.Add($"Col {i}", GetType(Integer))
            Else
                dt.Columns.Add($"Col {i}", GetType(String))
            End If
        Next

        For i As Integer = 1 To 21 - 1
            dt.Rows.Add($"Row {i}", i, $"Row {i}", i, $"Row {i}", i)
        Next

        Return dt
    End Function
End Class
